// GetProcAddress.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include <windows.h>
#include <psapi.h>

typedef struct _ANSI_STRING {
	USHORT Length;
	USHORT MaximumLength;
	PCHAR Buffer;
} ANSI_STRING, *PANSI_STRING;

typedef FARPROC (WINAPI* GETPROCADDRESS)( HMODULE, LPCSTR );
GETPROCADDRESS pGetProcAddress, pGetProcAddress2;

typedef NTSTATUS (WINAPI* LDRGETPROCEDUREADDRESS)( HMODULE, PANSI_STRING, WORD, PVOID );
LDRGETPROCEDUREADDRESS pLdrGetProcedureAddress;

int _tmain(int argc, _TCHAR* argv[])
{
	HMODULE hDll = LoadLibrary( _T("ntdll.dll") );
	ANSI_STRING str = {14,15,"GetProcAddress"};

	printf( "The address of GetProcAddress:\n\n" );

	pGetProcAddress = (GETPROCADDRESS)GetProcAddress( GetModuleHandle( _T("kernel32.dll") ), "GetProcAddress" );
	printf( "GetProcAddress         returns %x  ", pGetProcAddress );

	HMODULE hKernel32 = GetModuleHandle( _T("kernel32.dll") );
	MODULEINFO mi = {0};
	GetModuleInformation( GetCurrentProcess(), hKernel32, &mi, sizeof(mi) );

	if ( ( (LPBYTE)pGetProcAddress < (LPBYTE)mi.lpBaseOfDll ) || ( (LPBYTE)pGetProcAddress >= ( (LPBYTE)mi.lpBaseOfDll + mi.SizeOfImage ) ) ) {
		printf( "Out of kernel32.dll!\n" );
	}
	else {
		printf( "\n" );
	}

	pLdrGetProcedureAddress = (LDRGETPROCEDUREADDRESS)GetProcAddress( hDll, "LdrGetProcedureAddress" );

	pLdrGetProcedureAddress( GetModuleHandle( _T("kernel32.dll") ), &str, 0, &pGetProcAddress2 );
	printf( "LdrGetProcedureAddress returns %x\n", pGetProcAddress2 );

	FreeLibrary( hDll );

	return 0;
}
